;
;******************************************************************************
;******************************************************************************

;-----------------------------------------------------------------------------
; DIRECTIVES OF THE COMPILER
;-----------------------------------------------------------------------------
;$NOMOD51 
;$INCLUDE (reg52.inc)

USING  0

;-----------------------------------------------------------------------------
;		"Nombre de los pines de los PORTS"
;-----------------------------------------------------------------------------

;-----------------------------------------------------------------------------
;PORT0
;-----------------------------------------------------------------------------
;
DATABUS0			EQU    	0d  ;Linea 0 del Bus de datos
DATABUS1			EQU    	1d  ;Linea 1 del Bus de datos
DATABUS2			EQU    	2d  ;Linea 2 del Bus de datos
DATABUS3			EQU    	3d  ;Linea 3 del Bus de datos
DATABUS4			EQU    	4d  ;Linea 4 del Bus de datos
DATABUS5			EQU    	5d  ;Linea 5 del Bus de datos
DATABUS6			EQU    	6d  ;Linea 6 del Bus de datos
DATABUS7			EQU    	7d  ;Linea 7 del Bus de datos

;-----------------------------------------------------------------------------
;PORT1:
;-----------------------------------------------------------------------------
;
DEMUX_A2			EQU		1d  ;Seal Adderss de  DEMULTIPLEXOR A2


;-----------------------------------------------------------------------------
;PORT2
;-----------------------------------------------------------------------------
;

;-----------------------------------------------------------------------------
;PORT3:
;-----------------------------------------------------------------------------
DEMUX_A1			EQU		4d	 ;Seal Adderss de  DEMULTIPLEXOR A1
DEMUX_A0			EQU		5d	 ;Seal Adderss de  DEMULTIPLEXOR A0


;=============================================================================

;******************************************************************************
;******************************************************************************

;==============================================================================
;				"DECLARACION de vectores de interrupcion"
;==============================================================================
EXT0            EQU       03h
TIMER0          EQU       0Bh
EXT1            EQU       13h
TIMER1          EQU       1Bh
USART0          EQU       23h
TIMER2          EQU       2Bh

;==============================================================================
;				** DECLARACION DE VARIABLES **
;==============================================================================

;--------------------------------------------
;Variables de flags
;--------------------------------------------
Status_input00			DATA    20h
Status_input01          DATA    21h
Status_input02          DATA    22h
Status_input03          DATA    23h
FlagsSonido             DATA    24h
FlagsStatus1            DATA    25h
FlagsStatus2            DATA    26h
FlagsStatus3            DATA    28h

;--------------------------------------------
;Uso general
;--------------------------------------------

Cnt0	           	    DATA    30h
Cnt1              	    DATA    31h
tic10ms           	    DATA    32h

;--------------------------------------------
;Rutina display 7 Segmentos
;--------------------------------------------
DisplayChar0      	    DATA    33h
DisplayChar1     	    DATA    34h
DisplayChar2     	    DATA    35h
DisplayChar3     	    DATA    36h
CntRefr7SegDisp			DATA    37h

RamChar0				DATA    38h   ;Info SPO2.
RamChar1				DATA    39h   ;
RamChar2				DATA    3Ah   ;
RamChar3				DATA    3Bh   ;Estado de alarma de SPO2
                                      ;
RamChar4				DATA    3Ch   ;Info FP.
RamChar5				DATA    3Dh   ;
RamChar6				DATA    3Eh   ;
RamChar7				DATA    3Fh   ;Estado de alarma FP.

;--------------------------------------------
;Rutinas BCD
;--------------------------------------------
Reg0					DATA    40h
Reg1					DATA    41h
Reg2					DATA 	42h
L_Byte					DATA    43h
H_Byte					DATA  	44h




;==============================================================================
;				** DEFINICION DE FLAGS DE VARIABLES **
;==============================================================================

;-----------------------------------------------------------------------------


;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------

;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;
;	-- CODIGO -- CODIGO -- CODIGO -- CODIGO -- CODIGO -- CODIGO -- CODIGO --
;
;==============================================================================
;				** VECTORES DE INTERRUPCION **
;==============================================================================



		Org 00h
		jmp Start

		Org TIMER0
		jmp AtTimer0



;******************************************************************************
;******************************************************************************
Start:
		call  InicVars		  ;
		call  INITimers       ;Inicia  Timers.
		call  INIntrr         ;Inicia sistema de interrupciones.
		mov   SP,#08h         ;Muevo el stack al segundo banco de registros.
		mov   P2,#0FFh        ;Configurar P2 como entrada.

;-----------
;Loop1:
;;Greating mesage1: '8 8 8 8'               ;SPO2
		mov   DisplayChar0,#1d      		;
		mov   DisplayChar1,#2d     			;
		mov   DisplayChar2,#3d  		    ;
		mov   DisplayChar3,#4d     			;		
		clr   FlagsStatus1.SELEC_DISP		;		
		call  Display_Print         		;
	
Loop1:
		setb  P1.LED_RED					;
		call  Delay100ms          			;
		call  Delay100ms         		    ;
		call  Delay100ms         		    ;
		clr   P1.LED_RED            		;
		call  Delay100ms           		    ;
		call  Delay100ms         		    ;
		call  Delay100ms           			;
                                    	
		jmp   Loop1							;


;--------------------------------------------------------------------------
;******************************************************************************
;*  SUBRUTINAS:
;******************************************************************************

;******************************************************************************
; Subrutina: ATtimer0
;******************************************************************************
;
; Tarea: cada  10 ms al producirce una interrupcion  por el desbordamiento del
;        timer0. 
;
;
; Recibe: tic10ms o bien tic100ms.
;
; Devuelve: El buffer data_Rx
;
; Destruye: R3.
;******************************************************************************
ATtimer0:
		push     ACC	   ;
		push     B		   ;
		push     PSW	   ;
		push     AR0	   ;

		;*IniTimer0	
 		mov    TL0,#83h   	  ;Cargo el timer 0 con 922d (FC83h)para que se produsca 
		mov    TH0,#0FCh  	  ;una interrupcion cada 1 milisegundos.


;===============================

		dec   tic10ms

;===============================

        call    RefreshDisplay                 	;

;=========
end_timer:

		pop      AR0						   ;
		pop      PSW						   ;
		pop      B							   ;
		pop      ACC						   ;

		reti


;--------------------------------------------------------------------
;FUNCION: RefreshDisplay
;
;Dscipcion: Realiza el refresco de cada modulo del display.
;
;Entrada: RamChar0,RamChar1,RamChar2,RamChar3,RamChar4,RamChar5
;		  RamChar6,RamChar7	
;
;Salida: Nothings
;----------------------------------------------------------------------
RefreshDisplay:

        ;Setea Address del DEMULTIPLEXOR 74HC138 para lograr el refresco del
        ;cada modulo del Display.Tiempo de Refresco 1ms aprox.

		mov		A,CntRefr7SegDisp				;
                                                ;
		mov     C,ACC.0							;
		mov     P3.DEMUX_A0,C					;
												;
		mov     C,ACC.1							;
		mov     P3.DEMUX_A1,C		            ;
												;
		mov     C,ACC.2							;
		mov     P1.DEMUX_A2,C		            ;

;..............

        ;*****
        ;Introduce el dato en el DataBus del display 7 segmentos.
        ;*****
;..........
RefresMod0:
		mov		A,CntRefr7SegDisp				;
		cjne	A,#0,RefresMod1					;
        mov     A,RamChar0                      ;
        mov     P0,A                      		;
        jmp     ExitRefreshDisplay				;
;..........
RefresMod1:
		mov		A,CntRefr7SegDisp				;
		cjne	A,#1,RefresMod2					;
        mov     A,RamChar1                      ;
        mov     P0,A                      		;
       
        jmp     ExitRefreshDisplay				;
;..........
RefresMod2:
		mov		A,CntRefr7SegDisp				;
		cjne	A,#2,RefresMod3					;
        mov     A,RamChar2                      ;
        mov     P0,A                      		;

        jmp     ExitRefreshDisplay				;
;..........
RefresMod3:
		mov		A,CntRefr7SegDisp				;
		cjne	A,#3,RefresMod4					;
        mov     A,RamChar3                      ;
        mov     P0,A                      		;

        jmp     ExitRefreshDisplay				;
;..........
RefresMod4:
		mov		A,CntRefr7SegDisp				;
		cjne	A,#4,RefresMod5					;
        mov     A,RamChar4                      ;
        mov     P0,A                      		;

        jmp     ExitRefreshDisplay				;
;..........
RefresMod5:
		mov		A,CntRefr7SegDisp				;
		cjne	A,#5,RefresMod6					;
        mov     A,RamChar5                      ;
        mov     P0,A                      		;

        jmp     ExitRefreshDisplay				;
;..........
RefresMod6:
		mov		A,CntRefr7SegDisp				;
		cjne	A,#6,RefresMod7					;
        mov     A,RamChar6                      ;
        mov     P0,A                      		;

        jmp     ExitRefreshDisplay				;
;..........
RefresMod7:
		mov		A,CntRefr7SegDisp				;
		cjne	A,#7,ExitRefreshDisplay			;
        mov     A,RamChar7                      ;
        mov     P0,A                      		;

	    jmp     ExitRefreshDisplay				;

;------------------
ExitRefreshDisplay:
		inc	    CntRefr7SegDisp					;
		mov     A,CntRefr7SegDisp				;
		subb    A,#8d			                ;
		jc      end_RefreshDisplay				;
		mov		CntRefr7SegDisp,#0				;

;==================
end_RefreshDisplay:

		ret

;_______________________

;******************************************************************************
;SUBRUTINA DE INICIALIZACION DEL SISTEMA DE INTERUPCIONES.
;
;Interrupciones usadas:
;                       1) Externa INT0 (P3.2)
;                       2) Timer0
;                       3) Uart (En recepcion unicamente)
;******************************************************************************
INIntrr:

;**Reg. IE**
	setb ET0          ; Enable interrupt Timer0

;**TCON**              
	setb EA
	ret

;******************************************************************************
; Subrutina:INITimers
;******************************************************************************
;
; Tarea:inicializa :
;				 timer 0: modo 0(16 bits).
;				 timer 1: modo 2 autorecarga(al timer1 se lo debe usar en este 
;				          modo para poder emplearlo como generador  de baudios.
;				 timer 2: modo 16bits autorecarga. 
;
; Nota al usar el puerto serie del micro en modo 1, se pierde el timer1 , debido
;      a que el mismo es usado para elgir el Baud Rate(generador de baudios) de
;      la comunicacion.
;
;       9600,8,N,1.
;
;******************************************************************************
INITimers:
	 mov TMOD,#21h     ;Timer 1 trabajando en modo 2 autorecarga.
					   ;Timer 0 trabajando en modo 1 16 bits activado por TR0.
	 mov TH1,#0FBh     ;
	 
	 ;---------
	 mov    TL0,#83h   ;Cargo el timer 0 con 922d (FC83h)para que se produsca 
 	 mov    TH0,#0FCh  ;una interrupcion cada 1 milisegundos.

	 setb TR0          ;                  

	 ret
;---------------------

;******************************************************************************
; Subrutina:Delay10ms
;******************************************************************************
;
; Tarea:genera una demora , por interrupciones con el timer 0.
;
; Recibe:Nothing
;
; Devuelve:Nothing
;
; Destruye:Registro R3.
;******************************************************************************
Delay10ms:
	 mov  tic10ms,#1d
conti0:
	 mov  R3,tic10ms
	 cjne R3,#0,conti0

	 ret

;******************************************************************************
; Subrutina:Delay100ms
;******************************************************************************
;
; Tarea:genera una demora , por interrupciones con el timer 0.
;
; Recibe:Nothing
;
; Devuelve:Nothing
;
; Destruye:Registro R3.
;******************************************************************************
Delay100ms:
	 mov  tic10ms,#10d
conti1:
	 mov  R3,tic10ms
	 cjne R3,#0,conti1

	 ret

;******************************************************************************
; Subrutina:Delay250ms
;******************************************************************************
;
; Tarea:genera una demora , por interrupciones con el timer 0.
;
; Recibe:Nothing
;
; Devuelve:Nothing
;
; Destruye:Registro R3.
;******************************************************************************
Delay250ms:
	 mov  tic10ms,#25d
conti2:
	 mov  R3,tic10ms
	 cjne R3,#0,conti2

	 ret

;******************************************************************************
; Subrutina:Delay500ms
;******************************************************************************
;
; Tarea:genera una demora , por interrupciones con el timer 0.
;
; Recibe:Nothing
;
; Devuelve:Nothing
;
; Destruye:Registro R3.
;******************************************************************************
Delay500ms:
	 mov  tic10ms,#50d
conti3:
	 mov  R3,tic10ms
	 cjne R3,#0,conti3

	 ret

;******************************************************************************
; Subrutina:Delay1s
;******************************************************************************
;
; Tarea:genera una demora , por interrupciones con el timer 0
;
; Recibe:Nothing
;
; Devuelve:Nothing
;
; Destruye:Registro R3.
;******************************************************************************
Delay1s:
	 mov  tic10ms,#100d
conti4:
	 mov  R3,tic10ms
	 cjne R3,#0,conti4

	 ret
;------------------------

		;** Rutina de delay por software **

;******************************************************************************
; Subrutina: Delay10us
;******************************************************************************
;
; Tarea: Rutina de delay por software
;
; Recibe:Nothing
;
; Devuelve:Nothing
;
; Destruye:
;******************************************************************************
Delay10us:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	ret
;******************************************************************************
; Subrutina:_Delay100
;******************************************************************************
; Tarea: Rutina de delay por software
;
; Recibe:Nothing
;
; Devuelve:Nothing
;
; Destruye: Cnt0, Cnt1.
;******************************************************************************
_Delay100ms:

;Carga temp:

	 mov  Cnt1,#100   ;1ms*100=100ms
loopB1:
	 mov Cnt0,#100    ;1ms
loopA1:
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop
	 nop

	 djnz Cnt0,loopA1

	 djnz Cnt1,loopB1

	 ret

;-----------------



;********************************************************************
;                  Binary To BCD Conversion Routine
;
;    This routine converts a 16 Bit binary Number to a 5 Digit
;    BCD Number. This routine is useful since Intel 8x5x(8031)
;
;    The 16 bit binary number is input in locations L_Byte, H_Byte
;    The 5 digit BCD number is returned in R0, R1 and R2 with R0
;    containing the MSD in its right most nibble.
;
;*******************************************************************;
B2toBCD:
       clr   CY
       mov   R3,#16d

       mov   Reg0,#0d
       mov   Reg1,#0d
       mov   Reg2,#0d

Loop16:
       mov   A,L_Byte
       rlc   A
       mov   L_Byte,A
;---
       mov   A,H_Byte
       rlc   A
       mov   H_Byte,A
;----------
       mov   A,Reg2
       rlc   A
       mov   Reg2,A

       mov   A,Reg1
       rlc   A
       mov   Reg1,A

       mov   A,Reg0
       rlc   A
       mov   Reg0,A
;-------

       djnz  R3,adjDEC            ;Dec counter.
       jmp   EndConversionB2BCD   ;

adjDEC:
       mov   R0,#Reg2  	          ;Pass adress to pointer of Reg2.
       call  adjBCD    	    	  ;

       mov   R0,#Reg1        	  ;Pass adress to pointer of Reg1.
       call  adjBCD          	  ;

       mov   R0,#Reg0        	  ;Pass adress to pointer of Reg0.
       call  adjBCD          	  ;

       jmp   Loop16

EndConversionB2BCD:

       ret

;******************************************************************************
;  Rutine: adjBCD
;
;  Recibe: R0: pointer to RegX.
;******************************************************************************
adjBCD:
       mov   A,@R0		;Restore Value RegX.
       add   A,#03h             ;
       jnb   ACC.3,NoSum03h     ;If result nibble LSD > 7 then save.
       mov   @R0,A              ;Save value in RegX.
NoSum03h:
       mov   A,@R0              ;Restore Value RegX.
       add   A,#30h             ;
       jnb   ACC.7,NoSum30h     ;If result nibble MSD > 7 then save.
       mov   @R0,A              ;Save value in RegX.
NoSum30h:

       ret


;******************************************************************************
;Routine: ComprimeBCD
;
;Tarea: Comprime los digitos BCD que se ingresan en Register5(MSD),Register4,
;	Register3,Register2,Register1(LSD)(x.x.x.x.x) ,ubicandolos en Reg0,
;	Reg1,Reg2(x.xx.xx) ,de esta manera en cada RegX habra 2 digitos BCD.
;
;Recibe: en R0 la direccion del register1(LSD) de entrada.
;
;NOTA: Los registros debe definirce concecutivamente.
;******************************************************************************
ComprimeBCD:

		mov  A,@R0    ;Register1 (LSD).
		anl  A,#0fh   ;
		mov  Reg2,A   ;

		inc  R0       ;
		mov  A,@R0    ;Register2.
		anl  A,#0fh   ;
		swap A        ;
		orl  A,Reg2   ;
		mov  Reg2,A   ;Save register.

;-------------------
		inc  R0       ;
		mov  A,@R0    ;Register3.
		anl  A,#0fh   ;
		mov  Reg1,A   ;

		inc  R0       ;
		mov  A,@R0    ;Register4.
		anl  A,#0fh   ;
		swap A        ;
		orl  A,Reg1   ;
		mov  Reg1,A   ;Save register.
;------------------

		inc  R0       ;
		mov  A,@R0    ;Register5 (MSD).
		anl  A,#0fh   ;
		mov  Reg0,A   ;

;------------------
		ret

;******************************************************************************
;Routine: ExpandBCD
;
;Tarea: Expande los digitos BCD que se ingresan en Reg0(MSD),Reg1,Reg2(x.xx.xx)
;	a los registros:
;                       "Register5,Register4,Register3,Register2,Register1"
;                            x    .    x    .   x     .   x     .    x
;                           MSD                                     LSD
;
;       Con el formato de entrada cada byte contiene 2 digitosBCD y con el de
;       salida cada byte contine un digito BCD.
;
;Recibe: en R0 la direccion del register1(LSD) de salida.
;
;NOTA: Los registros debe definirce concecutivamente.
;
;******************************************************************************
ExpandBCD:
		mov  A,Reg2   ;
		anl  A,#0fh   ;
		mov  @R0,A    ;Register1 (LSD).

		mov  A,Reg2   ;
		anl  A,#0f0h  ;
		swap A        ;
		inc  R0       ;
		mov  @R0,A    ;Register2.

;-------------------

		mov  A,Reg1   ;
		anl  A,#0fh   ;
		inc  R0       ;
		mov  @R0,A    ;Register3.

		mov  A,Reg1   ;
		anl  A,#0f0h  ;
		swap A        ;
		inc  R0       ;
		mov  @R0,A    ;Register4.

;-------------------

		mov  A,Reg0   ;
		anl  A,#0fh   ;
		inc  R0       ;
		mov  @R0,A    ;Register5 (MSD).

;-------------------
		ret
		
;******************************************************************************
; Subrutina: Display_Print
;******************************************************************************
; Tarea: Imprime por diplay el contenido de los registros DisplayChar0(lsd),
;        DisplayChar1,DisplayChar2(msd),DisplayChar3(Alarma act);en cada uno
;		 de los 3 elementos del display.
;
; Recibe: 1-en DisplayChar0(lsd),DisplayChar1,DisplayChar2(msb) desplazamiento en la
;		   tabla de carateres.
;         2-Flag SELEC_DISP=0:Display SPO2, SELEC_DISP=1:display FP
;           indica sobre que indicador se esta escribiendo.
;
; Devuelve: RamChar0(lsd),RamChar1,RamChar2(msd) para SPO2
;			RamChar4(lsd),RamChar5,RamChar6(msd) para FP
;			RamChar3 Alarmas de SPO2. 
;			RamChar7 Alarmas de FP. 
;
;           Datos a refrescar sobre el display en la rutina de timer.
;
; Destruye:Nothing
;
;******************************************************************************
Display_Print:

;----------------------------------
;char0(lsd):
		mov   DPTR,#_7SEG_CHAR_TAB     	    ;Posicion de tabla 7 segmentos.
		mov   A,DisplayChar0   	       	    ;
		movc  A,@A+DPTR      	       	    ;Conversion from BCD to 7seg.
		jb    FlagsStatus1.SELEC_DISP,JFP1  ;
		mov   RamChar0,A     	       	    ;Ram Refresco Video SPO2
		jmp   char1							;

JFP1:    	                                ;
		mov   RamChar4,A     	         	;Ram Refresco Video FP
                                 
;==============================
char1:
		mov   A,DisplayChar1  	      		;
		cjne  A,#0,TurnOnDig1        		;Digit=0?
		mov   A,DisplayChar2  	     	    ;
		cjne  A,#0,TurnOnDig1        		;Digit to left=0?
		jmp   TurnOffDig1					;

;-----------
TurnOffDig1:  	                     		;	
		mov   DisplayChar1,#25 	       		;char ' '.
		mov   DPTR,#_7SEG_CHAR_TAB     		;Posicion de tabla 7 segmentos.
		mov   A,DisplayChar1   	    	    ;
		movc  A,@A+DPTR      		        ;Conversion from BCD to 7seg.
		jb    FlagsStatus1.SELEC_DISP,JFP2 	;
		mov   RamChar1,A     	       	    ;Ram Refresco Video SPO2
		jmp	  char2		  				    ;

JFP2:                                   	;
		mov   RamChar5,A     	       	    ;Ram Refresco Video FP
		jmp	  char2		  				    ;
	
;---------
TurnOnDig1:
		mov   DPTR,#_7SEG_CHAR_TAB   		;Posicion de tabla 7 segmentos.
		mov   A,DisplayChar1   	      		;
		movc  A,@A+DPTR      	       		;Conversion from BCD to 7seg.
		jb    FlagsStatus1.SELEC_DISP,JFP3 	;
		mov   RamChar1,A     	       	    ;Ram Refresco Video SPO2
		jmp   char2							;

JFP3:                                  	    ;
		mov   RamChar5,A     	       	    ;Ram Refresco Video FP

;==============================
char2:
		mov   DPTR,#_7SEG_CHAR_TAB 		    ;Posicion de tabla 7 segmentos.
		mov   A,DisplayChar2   		        ;
		movc  A,@A+DPTR     	 	        ;Conversion from BCD to 7seg.
		jb    FlagsStatus1.SELEC_DISP,JFP4 	;
		mov   RamChar2,A     	       	    ;Ram Refresco Video SPO2
		jmp   char3							;	

JFP4:	                                    ;
		mov   RamChar6,A     	       	    ;Ram Refresco Video FP


;==============================
char3:
		mov   DPTR,#_7SEG_CHAR_TAB 		    ;Posicion de tabla 7 segmentos.
		mov   A,DisplayChar3   		        ;
		movc  A,@A+DPTR     	 	        ;Conversion from BCD to 7seg.
		jb    FlagsStatus1.SELEC_DISP,JFP5 	;
		mov   RamChar3,A     	       	    ;Indicacion de alarmas  SPO2.
		jmp   ExitDisplay_Print				;

JFP5:
		mov   RamChar7,A     	       	    ;Indicacion de alarmas  FP.
	                 
;=================
ExitDisplay_Print:

		ret
;-----------

;******************************************************************************
; Tabla de caracteres 7 segmentos
;******************************************************************************

;-------------------------------------------------------------------------------
;FUNCION:7SEG_CHAR_TAB

;DESCRIPCION: Tabla de caracteres 7 segmentos
;
;ENTRADA: 
;SALIDA:
;-------------------------------------------------------------------------------
_7SEG_CHAR_TAB:

;---------------------------------------------------------------------------*
	  db       3Fh,06h,5Bh,4Fh,66h,6Dh,7Ch,07h,7Fh,67h,79h,50h,08h
;              0  | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | E | r | _ |         *
;Desplaz:      0  | 1 |	2 | 3 |	4 | 5 |	6 | 7 |	8 | 9 |10 |11 |12 |      	*
;---------------------------------------------------------------------------*
	  db 	  31h,3Eh,73h,71h,5Eh,38h,5Ch,54H,1Ch,70h,58h,30h,00h
;              T | U | P | F | d | L | o | n | u | t | c | l |' '|          *
;Desplaz:     13 |14 |15 |16 |17 |18 |19 |20 |21 |22 |23 |24 |25 |          *
;---------------------------------------------------------------------------*
	  db      77h,76h
;              A | H |                                                      *
;Desplaz:     26 |27 |                                                      *
;---------------------------------------------------------------------------*


;*****************************************************************************
	

